<template>
  <div>
    <div v-show="status === Status.LOADING">
      <content-loader-table
        :height="350"
        :num-rows="5"
      />
    </div>
    <div v-show="status === Status.SUCCESS">
      <b-form-group
        label="Filter"
        label-for="filter-input"
        label-cols-sm="1"
        label-align-sm="left"
        label-size="sm"
        class="mb-0"
        content-cols="4"
      >
        <b-input-group size="sm">
          <b-form-input
            id="filter-input"
            v-model="filter"
            type="search"
            placeholder="Type to Search"
          />

          <b-input-group-append>
            <b-button @click="filter = ''">
              Clear
            </b-button>
          </b-input-group-append>
        </b-input-group>
      </b-form-group>
      <b-row>&nbsp;</b-row>
      <b-table
        :current-page="currentPage"
        :per-page="perPage"
        :fields="fields"
        :items="locusProperties"
        :filter="filter"
        :sort-by.sync="sortBy"
        bordered
        small
        striped
      />
      <!-- This <b-row>...</b-row> block builds the pagination function for the table. -->
      <b-row align-h="between">
        <b-col>
          <b-row>
            <b-col>
              <b-form inline>
                <label class="mr-2">Show</label>
                <b-form-select
                  v-model="perPage"
                  :options="pageOptions"
                  class="mr-2"
                />
                <label class="mr-1">entries</label>
              </b-form>
            </b-col>
          </b-row>
          <b-row>
            <b-col>
              <p class="font-weight-lighter">
                Showing {{ pageStart }} to {{ pageEnd }} of {{ rows }} entries
                &nbsp;
                &nbsp;
                <vue-csv-downloader
                  :data="locusPropertiesExport"
                  :fields="fieldsexport"
                >
                  Download All Properties
                </vue-csv-downloader>
              </p>
            </b-col>
          </b-row>
        </b-col>
        <b-col>
          <b-pagination
            v-model="currentPage"
            :per-page="perPage"
            :total-rows="rows"
            align="right"
          />
        </b-col>
      </b-row>
    </div>
    <div v-show="status === Status.ERROR">
      <b-list-group>
        <b-list-group-item variant="danger">
          <h5>Error Loading Properties</h5>
          <p>There was an error loading locus properties.</p>
          <pre>{{ JSON.stringify(errorMessage, null, 2) }}</pre>
        </b-list-group-item>
      </b-list-group>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { LocusPropertyService } from '@/api';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';
import { Locus } from '@/common/types';
import VueCsvDownloader from 'vue-csv-downloader';

/* eslint-disable-next-line no-shadow */
enum Status {
  LOADING = 'LOADING',
  ERROR = 'ERROR',
  SUCCESS = 'SUCCESS',
}

export default Vue.extend({
  components: {
    ContentLoaderTable,
    VueCsvDownloader,
  },
  props: {
    locusPropertiesKVs: {
      required: true,
      type: [String],
    },
    locusId: {
      required: true,
      type: String,
    },
  },

  data() {
    return {
      Status,
      count: 0,
      locus: null as Locus | null,
      currentPage: 1,
      errorMessage: '',
      fields: [
        {
          key: 'key',
          label: 'Key',
        },
        {
          key: 'value',
          label: 'Value',
        },
      ],
      filter: null,
      loading: false,
      sortBy: 'key',
      sortDesc: true,
      status: Status.LOADING,
      pageOptions: [5, 10, 25, 50, 100, 200],
      perPage: 5,
      locusprops: this.locusPropertiesKVs,
      fieldsexport: ['key', 'value'],
    };
  },

  computed: {
    pageEnd(): number {
      const pageEnd = this.pageStart + this.perPage - 1;
      return pageEnd > this.rows ? this.rows : pageEnd;
    },
    pageStart(): number {
      return (this.currentPage - 1) * this.perPage + 1;
    },
    rows(): number {
      return this.locusProperties.length;
    },
    locusPropertiesExport(): { [key: string]: any }[] {
      if (this.locusPropertiesKVs) {
        return Object.entries(this.locusPropertiesKVs).map(([key, value]) => ({
          key,
          value,
        }));
      }
      return [];
    },

    locusProperties(): { [key: string]: any }[] {
      if (this.locusPropertiesKVs) {
        return Object.entries(this.locusPropertiesKVs).map(([key, value]) => ({
          key,
          value,
        }));
      }
      return [];
    },
  },

  mounted() {
    this.status = Status.SUCCESS;
    this.rows = this.locusProperties.length;
  },

  methods: {
    async fetchLocusProperties() {
      this.status = Status.LOADING;
      try {
        const { data } = await LocusPropertyService.get(this.locusId);
        this.locus = data;
        this.status = Status.SUCCESS;
      } catch {
        this.status = Status.ERROR;
      }
    },
  },
});
</script>

<style scoped></style>
